#[doc = "Register `INTR_CAN_MASK` reader"]
pub struct R(crate::R<INTR_CAN_MASK_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<INTR_CAN_MASK_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<INTR_CAN_MASK_SPEC>> for R {
    fn from(reader: crate::R<INTR_CAN_MASK_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `INTR_CAN_MASK` writer"]
pub struct W(crate::W<INTR_CAN_MASK_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<INTR_CAN_MASK_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<INTR_CAN_MASK_SPEC>> for W {
    fn from(writer: crate::W<INTR_CAN_MASK_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `INT_STATUS` reader - Mask bit for corresponding bit in interrupt request register."]
pub struct INT_STATUS_R(crate::FieldReader<bool, bool>);
impl INT_STATUS_R {
    pub(crate) fn new(bits: bool) -> Self {
        INT_STATUS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for INT_STATUS_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INT_STATUS` writer - Mask bit for corresponding bit in interrupt request register."]
pub struct INT_STATUS_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_STATUS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
        self.w
    }
}
#[doc = "Field `TT_COMPARE` reader - Mask bit for corresponding bit in interrupt request register."]
pub struct TT_COMPARE_R(crate::FieldReader<bool, bool>);
impl TT_COMPARE_R {
    pub(crate) fn new(bits: bool) -> Self {
        TT_COMPARE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TT_COMPARE_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TT_COMPARE` writer - Mask bit for corresponding bit in interrupt request register."]
pub struct TT_COMPARE_W<'a> {
    w: &'a mut W,
}
impl<'a> TT_COMPARE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u32 & 0x01) << 1);
        self.w
    }
}
#[doc = "Field `TT_CAPTURE` reader - Mask bit for corresponding bit in interrupt request register."]
pub struct TT_CAPTURE_R(crate::FieldReader<bool, bool>);
impl TT_CAPTURE_R {
    pub(crate) fn new(bits: bool) -> Self {
        TT_CAPTURE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TT_CAPTURE_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TT_CAPTURE` writer - Mask bit for corresponding bit in interrupt request register."]
pub struct TT_CAPTURE_W<'a> {
    w: &'a mut W,
}
impl<'a> TT_CAPTURE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u32 & 0x01) << 2);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Mask bit for corresponding bit in interrupt request register."]
    #[inline(always)]
    pub fn int_status(&self) -> INT_STATUS_R {
        INT_STATUS_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Mask bit for corresponding bit in interrupt request register."]
    #[inline(always)]
    pub fn tt_compare(&self) -> TT_COMPARE_R {
        TT_COMPARE_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Mask bit for corresponding bit in interrupt request register."]
    #[inline(always)]
    pub fn tt_capture(&self) -> TT_CAPTURE_R {
        TT_CAPTURE_R::new(((self.bits >> 2) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Mask bit for corresponding bit in interrupt request register."]
    #[inline(always)]
    pub fn int_status(&mut self) -> INT_STATUS_W {
        INT_STATUS_W { w: self }
    }
    #[doc = "Bit 1 - Mask bit for corresponding bit in interrupt request register."]
    #[inline(always)]
    pub fn tt_compare(&mut self) -> TT_COMPARE_W {
        TT_COMPARE_W { w: self }
    }
    #[doc = "Bit 2 - Mask bit for corresponding bit in interrupt request register."]
    #[inline(always)]
    pub fn tt_capture(&mut self) -> TT_CAPTURE_W {
        TT_CAPTURE_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "CAN Interrupt Mask (TTCAN + INT_STATUS Or)\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [intr_can_mask](index.html) module"]
pub struct INTR_CAN_MASK_SPEC;
impl crate::RegisterSpec for INTR_CAN_MASK_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [intr_can_mask::R](R) reader structure"]
impl crate::Readable for INTR_CAN_MASK_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [intr_can_mask::W](W) writer structure"]
impl crate::Writable for INTR_CAN_MASK_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets INTR_CAN_MASK to value 0"]
impl crate::Resettable for INTR_CAN_MASK_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
